/**
 * @file 意图处理类
 * @author yelvye@baidu.com
 */

const Bot = require('../../lib/Bot');
const VideoPlay = Bot.Directive.VideoPlayer.Play;
const VideoStop = Bot.Directive.VideoPlayer.Stop;

const videoUrl = 'http://dbp-media.bj.bcebos.com/075e93f1-d929-3793-88b5-3b53a7a60093%2Fvideo%2F1%E5%8C%97%E7%BE%8E%E5%A4%A7%E5%9C%B0%E5%90%AF%E7%A4%BA.mp4';


class InquireBot extends Bot {

    constructor(postData) {
        super(postData);

        this.addLaunchHandler(() => {
            this.waitAnswer();
            this.setExpectSpeech(false);
            let directive = new VideoPlay(videoUrl);
               
            return {
                outputSpeech: '欢迎使用',
                directives:[directive]
            };
        });

        this.addIntentHandler('ai.dueros.common.pause_intent', () => {
            let context = this.request.getData().context;
            if(context.VideoPlayer) {
                //this.setSessionAttribute("offset", context.VideoPlayer.offsetInMilliseconds||0);
                //this.setSessionAttribute("token", context.VideoPlayer.token);
            }

            let directive = new VideoStop();

            this.waitAnswer();
            this.setExpectSpeech(false);
            return {
                outputSpeech: '好的，已暂停',
                directives:[directive]
            };
        });

        this.addIntentHandler('ai.dueros.common.continue_intent', () => {
            let directive = new VideoPlay(videoUrl);

            let offset;// = this.getSessionAttribute("offset") || 0;
            let token;
            let context = this.request.getData().context;
            if(context.VideoPlayer) {
                directive.setToken(context.VideoPlayer.token);
                directive.setOffsetInMilliseconds(context.VideoPlayer.offsetInMilliseconds);
            }     

            this.waitAnswer();
            this.setExpectSpeech(false);
            return {
                outputSpeech: '好的，继续播放',
                directives:[directive]
            };
        });

        this.addDefaultEventListener(() => {
            //console.log("=================DDDDD================");
            this.waitAnswer();
            this.setExpectSpeech(false);
            return;
        });

        this.addSessionEndedHandler(() => {
            this.endSession();
            return {
                outputSpeech: '多谢使用'
            };
        });
    }
}


module.exports = InquireBot;
